// diction.cpp
// dictionary of English-Japanese words

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>

using namespace std;

const int maxwords=200;

struct word {
  string english;
  string japan;
  int count;
};

void getword (word [], int &);
void displaywords (word [], int);
void writewords (word [], int);
void readwords (word [], int &);


int main() {
  word dictionary[maxwords];
  int size=0;
  int choice;

  do {
    cout << "1--enter a pair of words" << endl;
    cout << "2--display all words" << endl;
    cout << "3--write to file" << endl;
    cout << "4--read from file" << endl;
    cout << "9--quit" << endl;
    cin >> choice;
    switch (choice) {
     case 1:  getword(dictionary, size);
       break;
     case 2:  displaywords(dictionary, size);
       break;
     case 3:  writewords(dictionary, size);
       break;
     case 4:  readwords(dictionary, size);
       break;
    }
  } while (choice != 9);
}


//********************************************************
void getword (word DB[], int &len) {
  cout << "Enter English word: ";
  cin >> DB[len].english;
  cout << "Enter Japanese equivalent word: ";
  cin >> DB[len].japan;
  len++;
}




//********************************************************
void displaywords (word DB[], int len) {
  int i;
  for (i=0; i<len; i++)
    cout << DB[i].english 
         << '\t' << DB[i].japan << endl;
}



//********************************************************
void readwords (word DB[], int &len) {
  char fname[40];
  ifstream inf;

  cout << "Enter name of file: ";
  cin >> fname;
  inf.open(fname);
  if (!inf) 
    cerr << "ERROR can't open: " << fname << endl;
  else {
    inf >> DB[len].english >> DB[len].japan;
    while (inf) {
      len++;
      inf >> DB[len].english >> DB[len].japan;
    }
  }
  inf.close();
}



//********************************************************
void writewords (word DB[], int len) {
  char fname[40];
  ofstream outf;
  int i;

  cout << "Enter name of file: ";
  cin >> fname;
  outf.open(fname);
  for (i=0; i<len; i++)
    outf << DB[i].english 
         << " " << DB[i].japan << endl;
  outf.close();
}



