// move_mouse.cpp
// Move "mouse" around a 2D world

#include <iostream>
#include <cstdlib>

using namespace std;

const int row_size=20;
const int col_size=row_size*2;

void get_start (int &, int &);
void display_world(char [][col_size]);
bool make_move(char [][col_size], int &, int &);


int main() {
  char W[row_size][col_size];
  int row, col;
  bool keep_going;

  //initialize world to all blanks
  for (int i=0; i<row_size; i++)
    for (int j=0; j<col_size; j++)
      W[i][j] = ' ';

  get_start(row,col);

  W[row][col] = 'M';

  do {
    display_world(W);
    keep_going = make_move(W,row,col);
  } while (keep_going);

}


//get starting position
void get_start (int &row, int &col) {
  do {
    cout << "Enter starting coordinates of mouse (row col): ";
    cin >> row >> col;
    if (row>=row_size || col>=col_size)
      cout << "  ERROR.  row must be <" << row_size
	   << "   column must be <" << col_size << endl;
  } while (row>=row_size || col>=col_size);
}



//display the board
void display_world(char W[][col_size]) {
		 
  cout << "\33[H\33[2J";    //ANSI screen clear

  for (int i=0; i<row_size; i++) {
    for (int j=0; j<col_size; j++)
      cout << W[i][j];
    cout << endl;
  }
}


bool make_move(char W[][col_size], int &row, int &col) {

  char dir;

  W[row][col] = ' ';   //clear mouse's current position

  do {
    cout << "u d r l q: ";//
    cin >> dir;
    switch (dir) {
    case 'u': if (row>0) row--;
      break;
    case 'd': if (row<row_size-1) row++;
      break;
    case 'l': if (col>0) col--;
      break;
    case 'r': if (col<col_size-1) col++;
      break;
    case 'q': return false;
      break;
    default: cout << "???  Again please" << endl;
    }
  } while (dir!='u' && dir!='d' && dir!='r' && dir!='l');

  W[row][col] = 'M';
  return true;
}


//Make sure mouse stays in world.
//Make random moves automatically.
//Slow down using the sleep() function.
//Slow down using clock().
//"Cat" chases the mouse.
//Multiple mice.  
//Mouse trail.
//etc.

