// primefac.cpp
//Prime factorization.  fundamental theorem of arithmetic: every number 
// (i.e. positive integer) is a product of a unique collection of primes.

#include <iostream>
#include <iomanip>

using namespace std;

const int maxprimes=30;

bool isPrime (unsigned long int);


int main() {

  int primes[maxprimes]={2,3,5,7,11,13,17,19,23,29,31,37,41,43,53,59,61,
                         67,73,79,83,89,97,101,103,107,109,113,127,131};
  int p;
  unsigned long int num;
  char another;

  do {
    cout << endl << "Enter number to calculate prime factorization of: ";
    cin >> num;
    p = 0;
    if (isPrime(num))
	cout << num;
    else
      while (num>1  && p<maxprimes) {
        while (num%primes[p] == 0) {
          num = num / primes[p];
          cout << setw(4) << primes[p];
        }
        p++;
      }

    if (p == maxprimes)
      cout << "  Sorry, has prime factor(s) larger than "
           << primes[maxprimes-1] << endl;

    cout << endl << endl << "Another? ";
    cin >> another;
  } while (another=='y' || another=='Y');
}



bool isPrime (unsigned long int num) {

  unsigned long int i;

  for (i=2; i<=sqrt(num); i++)
    if (num%i == 0)
      break;		// evenly divisible

  if (i <= sqrt(num))
    return false;
  else
    return true;
}
