#include <iostream>
#include <cstdlib>
#include <ctime>
#include <algorithm>      //STL sort

const int MAX=1000000;

void generate_array (int [], int, int);
void display_array (int [], int);
void selection_sort (int [], int);


int main () {

  int size, range;
  int A[MAX];
  int tempA[MAX];
  char display;

  srand(time(NULL));    //initialize random number generator

  cout << "Enter size of array (ie. number of ints to sort) (Max of " 
       << MAX << endl;
  cin >> size;

  cout <<"  Enter range limit (ie. ints range from 1 to ?): ";
  cin >> range;

  cout << "Display arrays? (y or n): ";
  cin >> display;

  generate_array(A,size,range);

  copy(A,A+size,tempA);    //STL copy

  if (display=='y') {
    cout << "UNSORTED:" << endl;
    display_array(A,size);
    cout << endl;
  }

  selection_sort(A,size);

  if (display=='y') {
    cout << "SORTED:" << endl;
    display_array(A,size);
    cout << endl;
  }


  //STL sort
  cout << "Now going to sort using sort" << endl;
  sort(tempA,tempA+size);
  cout << "done.  Do you want to display it? (y or n) " << endl;
  cin >> display;
  if (display == 'y')
    display_array(tempA,size);
  cout << endl;
}





//*****************************************************************
void generate_array (int A[], int size, int range) {

  for (int i=0; i<size; i++) 
    A[i] = rand() % range;
}


//*****************************************************************
void display_array (int A[], int size) {

  for (int i=0; i<size; i++) 
    cout << " " << A[i];
}




//***********************************************************

void selection_sort (int A[], int size) {

  int i, j, min, temp;

  for (i=0; i<size-1; i++) {

    min = i;

    for (j=i+1; j<size; j++)
      if (A[j] < A[min])
	min = j;

    temp = A[i];
    A[i] = A[min];
    A[min] = temp;
  }
}




